<template>
  <v-dialog
      v-model="dialog"
      :width="isMobile || fullscreen ? undefined : 'auto'"
      :height="isMobile || fullscreen ? undefined : modalHeight"
      :fullscreen="isMobile || fullscreen"
      :transition="transition"
      :max-height="isMobile || fullscreen ? undefined : '74%'"
      :persistent="persistent"
      @click:outside="onClickOutside"
    >
      <template #activator="{ props }">
        <slot name="activator-div" v-bind="props">
          <div v-bind="props">
            <slot name="activator">
              <svn-button :variant="activatorVariant">
                <template #button-text>
                  <slot name="activator-text">
                    {{ activatorText }}
                  </slot>
                </template>
              </svn-button>
            </slot>
          </div>
        </slot>
      </template>

    <slot name="modal">
      <div
        class="flex flex-col bg-white h-full shadow-light-grey"
        :class="[modalClass(), modalCustomClass]"
      >
        <slot
          name="header"
          :close="closeModal"
        >
          <div
            class="flex px-4 py-2 items-center justify-between h-[64px] border-b border-middle-grey relative"
            :class="[headerClass(), headerCustomClass]"
          >
            <div
              class="flex font-medium w-full left-0 px-4"
              :class="[headerTitleClass(), headerTitleClassPosition()]"
            >
              <slot name="header-text">
                {{ modalTitle }}
              </slot>
            </div>
            <div class="flex justify-between w-full">
              <div v-if="prependHeaderIcon">
                <svn-icon-button
                  :icon="prependHeaderIcon"
                  variant="plain"
                  color-class="!text-dark-grey hover:!bg-very-light-grey active:!bg-light-grey"
                  @click="prependClickEvent()"
                />
              </div>
              <div
                v-if="appendHeaderIcon"
                :class="[appendHeaderIconClass()]"
              >
                <svn-icon-button
                  :icon="appendHeaderIcon"
                  variant="plain"
                  color-class="!text-dark-grey hover:!bg-very-light-grey active:!bg-light-grey"
                  @click="appendClickEvent()"
                />
              </div>
            </div>
          </div>
        </slot>

        <slot name="content">
          <div class="h-full w-full overflow-y-auto">
            <slot name="content-body"/>
          </div>
        </slot>

        <slot name="bottom-content">
          
        </slot>
      </div>
    </slot>
  </v-dialog>
</template>

<script setup>
import {onMounted, onUnmounted, ref} from "vue";
import SvnButton from "@/components/button/SvnButton.vue";
import SvnIconButton from "@/components/button/SvnIconButton.vue";

const dialog = ref(false)

const emit = defineEmits(['prependIconClick', 'appendIconClick', 'onClickOutside'])

const props = defineProps({
  fullscreen: {
    type: Boolean,
    default: false,
  },
  transition: {
    type: String,
    default: 'dialog-bottom-transition'
  },
  persistent: {
    type: Boolean,
    default: false
  },
  fullheight: {
    type: Boolean,
    default: false
  },
  activatorText: {
    type: String,
    default: 'Open Modal'
  },
  activatorVariant: {
    type: String,
    default: 'default'
  },
  modalTitle: {
    type: String,
    default: 'Create a new template'
  },
  modalHeight: {
    type: String,
    default: 'auto'
  },
  modalTitleCenter: {
    type: Boolean,
    default: false,
  },
  verticalHeader: {
    type: Boolean,
    default: false
  },
  prependHeaderIcon: {
    type: String,
    default: '',
  },
  appendHeaderIcon: {
    type: String,
    default: 'mdi:close'
  },
  appendIconCloseModal: {
    type: Boolean,
    default: true
  },
  headerCustomClass: {
    type: String,
    default: ''
  },
  modalCustomClass: {
    type: String,
    default: ''
  },
})

const isMobile = ref(false)

onMounted(() => {
  isMobile.value = window.innerWidth < 640
  window.addEventListener("resize", handleWindowResize)
})

onUnmounted(() => {
  window.removeEventListener("resize", handleWindowResize)
})

const handleWindowResize = (e) => {
  isMobile.value = e.target.innerWidth < 640
}

const headerClass = () => {
  if (props.verticalHeader) {
    return "flex-col-reverse h-[96px] justify-center gap-2"
  }
}

const headerTitleClass = () => {
  if (props.prependHeaderIcon) {
    return "justify-center"
  } else if (props.modalTitleCenter) {
    return "justify-center"
  } else {
    return "justify-left"
  }
}

const modalClass = () => {
  let customClass = ''

  customClass += `w-[600px] ${props.fullheight ? 'min-h-full' : 'min-h-[320px]'}`

  if (isMobile.value || props.fullscreen) {
    customClass += ' !w-full'
  } else {
    customClass += ' rounded-2xl'
  }

  return customClass
}

const headerTitleClassPosition = () => {
  if (props.verticalHeader) {
    return "justify-center"
  } else {
    return "absolute"
  }
}

const appendHeaderIconClass = () => {
  if (props.prependHeaderIcon) {

  } else {
    return "flex justify-end w-full"
  }
}

const appendClickEvent = () => {
  emit("appendIconClick")
  if (props.appendIconCloseModal) dialog.value = false
}

const onClickOutside = () => {
  emit("onClickOutside")
}

const closeModal = () => {
  dialog.value = false
}

defineExpose({
  dialog
})
</script>
